local show_infamy_menu = true
local REQUIRED_WAIT_TIME = 5 --time in seconds one must wait for the button to become valid




local modpath = ModPath

--yeah maybe people don't want to be reminded that i can go infamy every single time you know
function MenuCallbackHandler:become_infamous(params)
	if not self:can_become_infamous() then
		return
	end
	local no_clbk = params and params.no_clbk
	if no_clbk then 
		no_clbk() --god FUCK OFF some people just want to look at their infamy tree
	end
	return
end

Hooks:Add("LocalizationManagerPostInit", "hideinfamybutton_addstrings", function(loc)
	loc:add_localized_strings({
		hideinfamybutton_already_max_title = "Max infamy reached",
		hideinfamybutton_already_max_desc = "You're already at max infamy!\n\n...fuckin' sweaty tryhard no-life.\nlol jk, me too though",
		hideinfamybutton_not_at_menu_title = "Nope!",
		hideinfamybutton_not_at_menu_desc = "You must be at the main menu to Become Infamous.",
		hideinfamybutton_too_fast_title = "Whoa there, pardner!",
		hideinfamybutton_too_fast_desc = "You clicked through the menu too fast!\nWouldn't want to accidentally lose all that progress, now, would we?\n\nPlease wait " .. REQUIRED_WAIT_TIME .. " seconds before confirming Becoming Infamous.",
		hideinfamybutton_passagg_ok = "ok fine MOM jeez",
		hideinfamybutton_infamy_safety_title = "Safety",
		hideinfamybutton_infamy_safety_desc = "This option must be unchecked in order to become infamous through this menu."
	})
end)

Hooks:Add("MenuManagerInitialize", "hideinfamybutton_menu_postinit", function(menu_manager)
	local safety_toggle
	MenuCallbackHandler.callback_hideinfamybutton_close = function(self)
		if safety_toggle and (safety_toggle:value() ~= "on") then 
			safety_toggle:toggle()
			--this is like one of those machines people make that's just a switch that runs a motor to turn the switch off whenever you turn it on
		end
	end
	MenuCallbackHandler.callback_hideinfamybutton_togglesafety = function(self,item)
		safety_toggle = item		
	end
	
	MenuCallbackHandler.become_infamous_but_actually_for_real = function(self)
		if Utils:IsInGameState() then 
			QuickMenu:new(managers.localization:text("hideinfamybutton_not_at_menu_title"),managers.localization:text("hideinfamybutton_not_at_menu_desc"),{{text = managers.localization:text("hideinfamybutton_passagg_ok"),is_cancel_button = true}},true)
			return
		end
		if (not safety_toggle) or (safety_toggle:value() == "on") then 
			managers.menu:post_event("goat_says_meh")
			return
		end
		
		if not self:can_become_infamous() then
			if managers.experience:current_rank() < #tweak_data.infamy.ranks then 
				managers.menu:show_infamous_message(false) --"can't infamy" dialog
			else
				QuickMenu:new(managers.localization:text("hideinfamybutton_already_max_title"),managers.localization:text("hideinfamybutton_already_max_desc"),{{
					is_cancel_button = true,
					text = managers.localization:text("hideinfamybutton_passagg_ok")
				}},true)				
				--you're already at max rank, you cold pizza
			end
			return
		end
		local infamous_cost = Application:digest_value(tweak_data.infamy.ranks[managers.experience:current_rank() + 1], false)
		if infamous_cost <= managers.money:offshore() and managers.experience:current_level() >= 100 then
			local t = Application:time()
			QuickMenu:new(managers.localization:text("dialog_become_infamous"),managers.localization:text("menu_dialog_become_infamous"),{
				{
					text = managers.localization:text("menu_become_infamous"),
					
					callback = function()
						if Application:time() > REQUIRED_WAIT_TIME + t then 
							--basically the contents of MenuCallbackHandler:become_infamous()
						
							local rank = managers.experience:current_rank() + 1
						
							managers.menu:open_node("blackmarket_preview_node",{
								{
									back_callback = callback(MenuCallbackHandler, MenuCallbackHandler, "_increase_infamous",
										function() managers.menu:open_node("infamytree") end
									)
								}
							})
					
							managers.menu:post_event("infamous_stinger_level_" .. (rank < 10 and "0" or "") .. tostring(rank))
							managers.menu_scene:spawn_infamy_card(rank)
						else
							managers.menu:post_event("bdz_visor_lost") -- or "play_pln_gen_dir_07" for bain saying "no no no NO!"
							
							QuickMenu:new(managers.localization:text("hideinfamybutton_too_fast_title"),managers.localization:text("hideinfamybutton_too_fast_desc"),{{
								text = managers.localization:text("hideinfamybutton_passagg_ok"),
								callback = function() 
									self:become_infamous_but_actually_for_real()
								end,
								is_cancel_button = true
							}},true)
						end
					end
				},
				{
					text = managers.localization:text("dialog_no"),
					is_cancel_button = true,
					is_focused_button = true
				}
			},true)
		else
			managers.menu:show_infamous_message(false) --"can't infamy" dialog
		end

	end
	if show_infamy_menu then 
	--can't figure out how to load this conditionally. oh well!
		MenuHelper:LoadFromJsonFile(modpath .. "menu_infamy_confirmation.txt",{},{safety = true})
	end
end)